/*
   Feet of Fury

   editor/ed_popup.cc

   Copyright (C)2002 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.
*/

/*

 PUBLIC SOURCE NOTE:

 This file is no longer used. It's one of the apocryphal pieces of FoF
 that never made it into the final cut due to time.

*/

#include "global.h"

// Constructor / Destructor
EditorPopup::EditorPopup(const char * prompt, char * text, GameplaySkin * skin) {
	m_prompt = prompt;
	m_text = text;
	m_curpos = strlen(m_text);
	m_gpskin = skin;
	m_state = StateInput;
	m_abort = false;
}

EditorPopup::~EditorPopup() { }

void EditorPopup::process_key(int k) {
	switch(k) {
	case (KBD_KEY_LEFT << 8):
		if (m_curpos > 0)
			m_curpos--;
		break;
	case (KBD_KEY_RIGHT << 8):
		if (m_curpos < (int)strlen(m_text))
			m_curpos++;
		break;
	case (KBD_KEY_HOME << 8):
		m_curpos = 0;
		break;
	case (KBD_KEY_END << 8):
		m_curpos = strlen(m_text);
		break;
	case (KBD_KEY_DEL << 8):
		if (m_curpos < (int)strlen(m_text)) {
			strcpy(m_text + m_curpos, m_text + m_curpos + 1);
		}
		break;
	case 8:
		if (m_curpos > 0) {
			m_curpos--;
			strcpy(m_text + m_curpos, m_text + m_curpos + 1);
		}
		break;
	case 13:
		m_state = StateDieing;
		m_abort = false;
		break;
	case 27:
		m_state = StateDieing;
		m_abort = true;
		break;
	case (KBD_KEY_S3 << 8):
		m_text[0] = 0;
		m_curpos = 0;
		break;
	default:
		if (k >= ' ' && k <= 126) {
			if (m_curpos < (int)strlen(m_text)) {
				char tmp[strlen(m_text)+1];
				strcpy(tmp, m_text + m_curpos);
				m_text[m_curpos] = k;
				m_curpos++;
				strcpy(m_text + m_curpos, tmp);
			} else {
				m_text[m_curpos] = k;
				m_curpos++;
				m_text[m_curpos] = 0;
			}
		} else {
			printf("Unknown keypress %04x\n", k);
		}
		break;
	}
}

void EditorPopup::control_per_frame() {
	int		i;

	// Any keys available?
	while ( (i=kbd_get_key()) != -1 ) {
		process_key(i);
	}
}

void EditorPopup::visual_per_frame() {
	// Window frame
	glColor4f(0.1f, 0.3f, 0.1f, 0.9f);
	glDisable(GL_TEXTURE_2D);
	glLoadIdentity();
	glBegin(GL_QUADS);
		glVertex3f(320.0f - 240.0f, 240.0f - 60.0f, 98.0f);
		glVertex3f(320.0f - 240.0f, 240.0f + 60.0f, 98.0f);
		glVertex3f(320.0f + 240.0f, 240.0f + 60.0f, 98.0f);
		glVertex3f(320.0f + 240.0f, 240.0f - 60.0f, 98.0f);
	glEnd();

	// Text entry background
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glBegin(GL_QUADS);
		glVertex3f(320.0f - 230.0f, 240.0f - 10.0f, 98.1f);
		glVertex3f(320.0f - 230.0f, 240.0f + 10.0f, 98.1f);
		glVertex3f(320.0f + 230.0f, 240.0f + 10.0f, 98.1f);
		glVertex3f(320.0f + 230.0f, 240.0f - 10.0f, 98.1f);
	glEnd();

	// Cursor
	float width, height;
	char tmp[strlen(m_text)+1]; strncpy(tmp, m_text, m_curpos); tmp[m_curpos] = 0;
	m_gpskin->fnt->get_size(&width, &height, 20.0f, tmp);
	
	float cpx = (320.0f - 225.0f) + width;
	float cpy = (240.0f - 10.0f);

	float cpx2;
	if (m_curpos < (int)strlen(m_text)) {
		tmp[m_curpos] = m_text[m_curpos];
		tmp[m_curpos+1] = 0;
		m_gpskin->fnt->get_size(&width, &height, 20.0f, tmp);
		cpx2 = (320.0f - 225.0f) + width;
	} else {
		m_gpskin->fnt->get_size(&width, &height, 20.0f, "A");
		cpx2 = cpx + width;
	}
	
	glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
	glBegin(GL_QUADS);
		glVertex3f(cpx, cpy, 98.1f);
		glVertex3f(cpx, cpy + 20.0f, 98.2f);
		glVertex3f(cpx2, cpy + 20.0f, 98.2f);
		glVertex3f(cpx2, cpy, 98.2f);
	glEnd();

	glEnable(GL_TEXTURE_2D);

	// Draw the prompt text
	m_gpskin->fnt->begin();
	m_gpskin->fnt->set_color(1.0f, 1.0f, 1.0f);
	m_gpskin->fnt->draw(320.0f, 240.0f - 60.0f + 32.0f - width/2.0f, 98.5f, 20.0f, m_prompt, 1.0f);

	// Draw the entry text
	m_gpskin->fnt->set_color(0.0f, 0.0f, 0.0f);
	m_gpskin->fnt->draw(320.0f - 225.0f, 240.0f + 6.0f, 98.5f, 20.0f, m_text, 1.0f);
	m_gpskin->fnt->end();
}

