/*      
   Feet of Fury
        
   gameplay/bgeffects/top_scope.h

   Copyright (C)2002 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.
*/

#ifndef __TOP_SCOPE_H
#define __TOP_SCOPE_H

#include "bgeffects.h"

#define SCOPE_WAVECNT 64

// A 3D oscilliscope showing a morphing approximation of the
// sound pumping out the speakers.
class TopScope : public TopDrawable {
public:
	TopScope();
	virtual ~TopScope();

	virtual void draw(int list);
	virtual void nextFrame();

	static void drawCube(float p1[3], float p2[3], uint32 colors[6]);

	void callback(int hz, int channels, void ** buffer, int * samplecnt);

	static void callbackStatic(void * obj, int hz, int channels, void ** buffer, int * samplecnt);

private:
	mutex_t	* m_mutex;
	int16	m_buffer[3][16384];
	int	m_buffercnt[3];
	uint64	m_lasttime;
	int	m_takeframes;
	bool	m_newbuffer;

	typedef struct {
		float	pcur, pdelta;
	} wavepnt_t;
	wavepnt_t	m_wave[SCOPE_WAVECNT];

	float	m_rot;
};

#endif	/* __TOP_SCOPE_H */

