/*      
   Feet of Fury
        
   global.h

   Copyright (C)2002 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.
*/

#ifndef __GLOBAL_H
#define __GLOBAL_H

// I18N stuff
#define _(String) String
#define N_(String) String

// Basic KOS includes
#include <kos.h>
#include <dc/matrix.h>
#include <dc/matrix3d.h>

// KGL
#include <GL/gl.h>
#include <GL/glu.h>

// Ogg Vorbis
#include <oggvorbis/sndoggvorbis.h>

// PNG
#include <png/png.h>

// Parallax
#include <plx/matrix.h>
#include <plx/sprite.h>
#include <plx/texture.h>
#include <plx/list.h>
#include <plx/color.h>
#include <plx/context.h>

// Tsunami
#include <tsu/drawable.h>
#include <tsu/animation.h>
#include <tsu/font.h>
#include <tsu/texture.h>
#include <tsu/sound.h>
#include <tsu/trigger.h>
#include <tsu/vector.h>
#include <tsu/anims/alphafader.h>
#include <tsu/anims/expxymover.h>
#include <tsu/anims/logxymover.h>
#include <tsu/anims/tintfader.h>
#include <tsu/drawables/banner.h>
#include <tsu/drawables/label.h>
#include <tsu/drawables/scene.h>
#include <tsu/triggers/chainanim.h>
#include <tsu/triggers/death.h>

// ANSI C stuff
#include <stdlib.h>
#include <math.h>

// This is used in a lot of places thanks to 'hz'
#include "gfx.h"

// Ditto on this for swapcd_enabled
#include "main.h"

/* // Drawables and Animations
#include "textdisplay.h"	// generic
#include "slideshow.h"		// generic
#include "topbar.h"		// menu_main
#include "bubble_selector.h"	// menu_main
#include "gridselector.h"	// menu_char
#include "cube.h"		// generic
#include "bubble.h"		// generic
#include "scrollybg.h"		// generic
#include "cdtray.h"		// menu_stage
#include "songinfo.h"		// menu_stage
#include "gamemode.h"		// menu_stage
#include "lifemeter.h"		// gameplay
#include "combometer.h"		// gameplay
#include "combobomb.h"		// gameplay
#include "winner.h"		// gameplay
#include "winticks.h"		// gameplay
#include "wavetxr.h"		// demo
#include "bubblefield.h"	// menu_char
#include "scroller.h"		// menu_char
#include "mouse.h"		// ??
#include "plasma.h"		// generic
#include "loadhoops.h"		// bgeffects
#include "cubetunnel.h"		// bgeffects
#include "bouncetxr.h"		// generic
#include "starfield.h"		// generic
#include "rotbanner.h"		// generic
#include "tube.h"		// generic

// main/genmenu.cc
#include "genmenu.h"

// main/plrgenmenu.cc
#include "plrgenmenu.h"

// demo/demo.cc
#include "demo.h"

// about/tunnel.cc
// #include "tunnel.h"

// main/loading.cc
#include "loading.h"

// menu_main/menu_main.cc
#include "menu_main.h"

// gameplay/bgeffects
#include "bgeffects.h"

// gameplay
#include "wordlist.h"
#include "step.h"
#include "stepbomb.h"
#include "gpstate.h"

// main/character.cc
#include "character.h"

// gameplay/gpskin.cc
#include "gpskin.h"

// gameplay/stepdata.cc
#include "stepdata.h"

// gameplay/plrstate.cc
#include "plrstate.h"

// gameplay/player.cc
#include "player.h"

// gameplay/gameplay.cc
#include "gameplay.h"

// menu_char/menu_char.cc
#include "menu_char.h"

// menu_stage/menu_stage.cc
#include "menu_stage.h"

// editor/editor.cc
#include "ed_popup.h"
#include "editor.h"

// main/lua.cc
// #include "foflua.h"

// menu_win/menu_win.cc
#include "menu_win.h"

// menu_options/menu_options.cc
#include "menu_options.h"

// main/options.cc
#include "options.h"

// main/bkgloader.cc
void bkgLoaderBegin();
void bkgLoaderWait();
bool bkgLoaderDone(); */

#endif	/* __GLOBAL_H */

