/*      
   Feet of Fury
        
   winner.h

   Copyright (C)2002 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.
*/

#ifndef __WINNER_H
#define __WINNER_H

class Winner : public Drawable {
public:
	Winner();
	virtual ~Winner();

	struct StarPos {
		StarPos() { }
		StarPos(float xx, float yy, float ss) {
			x = xx;
			y = yy;
			s = ss;
			col = Color(0,1,1,1);
			dcol = Color(0,0,0,0);
		}
		void push() {
			col += dcol;
		}
		float	x, y, s;
		Color	col, dcol;
	};

	// Set the winning side and reset our parameters
	void setSide(int s);

	void drawOne(StarPos *sp);
	void drawWinner();
	virtual void draw(int list) {
		if (list != PLX_LIST_TR_POLY)
			return;
		drawWinner();
	}

	virtual void nextFrame();

private:
	StarPos		m_stars[6];
	int		m_frame;
	int		m_side;
	RefPtr<Texture>	m_txr_star, m_txr_winner;
};

#endif	/* __WINNER_H */

