--
-- Feet of Fury
--
-- Copyright (C)2002 Cryptic Allusion, LLC
--
-- See the file LICENSE for more info on usage.
--
-- PUBLIC SOURCE NOTE:
--
-- This file is no longer used. It's one of the apocryphal pieces of FoF
-- that never made it into the final cut due to time.
--

--
-- This Lua script contains everything that FoF will use during
-- the whole game, including the demo mode script and the character
-- scripting (though we don't use that yet).
--
   

-- Called to initialize the demo. This will load up all of the
-- textures we need and so forth.
function demo_setup()
	-- Put some debug notification on the console
	write("Starting demo_setup()\n")
	
	-- We'll need 5 textures
	demo_txr_cnt(5)

	-- Now load those textures
	demo_txr_load(0, "gfx/demo/controller.png")
	demo_txr_load(1, "gfx/demo/controller_dpad_left.png")
	demo_txr_load(2, "gfx/demo/controller_x.png")
	demo_txr_load(3, "gfx/demo/controller_dpad_b.png")
	demo_txr_load(4, "gfx/demo/ddrmat.png")

	-- All done!
	write("Finished demo_setup()\n")
end

-- PlayerVisuals play for N beats function
-- The demo DWI is 180BPM, so each beat is 20 frames.
function demo_pv_beats(n)
	-- Get rid of the text
	msg = { }
	if demo_text(msg) then return 1 end

	-- Start the PV, pause, then stop it again.
	if demo_pv_start() then return 1 end
	if demo_sleep(n * 20) then return 1 end
	if demo_pv_pause() then return 1 end

	return nil
end

-- Called to do the demo. When this function returns, demo mode will
-- be completely over.
function demo()
	-- Put some debug notification on the console
	write("Starting demo()\n")

	-- Bring in the picture of the controller
	if demo_txr_switch(0, 1) then return end

	-- Put up the first help string and pause
	msg = {
		"In Feet of Fury, you will",
		"use the controller to tap",
		"out a pattern with the beat",
		"of the background music."
	}
	if demo_text(msg) then return end
	if demo_sleep(6*60) then return end

	-- Bring in the playervisuals object, start it playing,
	-- and let it go until the first arrow will hit the top.
	if demo_pv_sethit(1) then return end
	if demo_pv_fadein() then return end
	if demo_pv_beats(16) then return end

	-- Second help string and pause
	msg = {
		"When an arrow reaches the",
		"top of the screen, push",
		"either the D-PAD or A/X/Y/B",
		"button corresponding to that",
		"direction. The D-PAD and",
		"A/X/Y/B methods are exactly",
		"equivalent."
	}
	if demo_text(msg) then return end
	for i=1,10 do
		if demo_txr_switch(1,0) then return end
		if demo_sleep(30) then return end
		if demo_txr_switch(2,0) then return end
		if demo_sleep(30) then return end
	end
	if demo_txr_switch(0,0) then return end

	-- Let the player visuals go again for another 8 beats.
	if demo_pv_beats(6) then return end

	-- Third help string and pause
	msg = {
		"If more than one arrow is",
		"present on a single line,",
		"then press both directions.",
		"You can use both the D-PAD",
		"and A/X/Y/B controls."
	}
	if demo_text(msg) then return end
	for i=1,8 do
		if demo_txr_switch(3,0) then return end
		if demo_sleep(30) then return end
		if demo_txr_switch(0,0) then return end
		if demo_sleep(30) then return end
	end

	-- Let the pv go again for another 8 beats.
	if demo_pv_beats(8) then return end

	-- Fourth help string and pause
	msg = {
		"In VS mode, a flashing arrow",
		"signifies that an ARROW BOMB",
		"is possible. If you hit this",
		"arrow pattern, it will \"send\"",
		"your combo to your opponent.",
		"Missing this arrow will not",
		"penalize you."
	}
	if demo_text(msg) then return end
	if demo_sleep(10*60) then return end

	-- Let the pv go again for another 6 beats.
	if demo_pv_sethit(0) then return end
	if demo_pv_beats(11) then return end

	-- Fifth help string and pause
	msg = {
		"Missing an arrow stops your",
		"combo and reduces your",
		"health meter. The player",
		"with the most health at the",
		"end of the round wins."
	}
	if demo_text(msg) then return end
	if demo_sleep(10*60) then return end

	-- Get rid of the playervisuals
	msg = { }
	if demo_text(msg) then return end
	if demo_pv_fadeout() then return end

	-- Bring in the DDR mat texture
	if demo_txr_switch(4,1) then return end
	if demo_sleep(1*60) then return end

	-- Sixth help string and pause
	msg = {
		"You may also use DDR(tm)",
		"pads to play Feet of Fury.",
		"Simply plug them into the",
		"controller ports as normal."
	}
	if demo_text(msg) then return end
	if demo_sleep(6*60) then return end

	-- Fade out the DDR mat texture
	msg = { }
	if demo_text(msg) then return end
	if demo_txr_switch(-1,1) then return end

	-- All done.. end of demo!
	write("Finishing demo()\n")
	return test
end

