/*
   Feet of Fury

   vmu.cc

   Copyright (C)2002 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.
*/

#include "global.h"
#include "vmu.h"

#include "logo_vmu.xbm"

static void flipLogo() {
	uint8 logo_bits[48*32/8];
	int x, y;

	for (y=0; y<32; y++) {
		for (x=0; x<48/8; x++) {
			logo_bits[y*48/8 + x] = logo_vmu_bits[(31-y)*48/8 + ((48/8 - 1) - x)];
		}
	}

	memcpy(logo_vmu_bits, logo_bits, 48*32/8);
}

static semaphore_t * quit_sem;
static kthread_t * thd_hnd;

static void vmuThreadproc(void *p) {
	printf("vmuThreadproc: started\n");
	do {
		maple_device_t * dev;
		int i;

		i = 0;
		while ( (dev = maple_enum_type(i++, MAPLE_FUNC_LCD)) ) {
			vmu_draw_lcd(dev, logo_vmu_bits);
		}
	} while (sem_wait_timed(quit_sem, 1000) == -1);
	printf("vmuThreadproc: finished\n");
}

void vmuInit() {
	flipLogo();
	quit_sem = sem_create(0);
	thd_hnd = thd_create(vmuThreadproc, NULL);
}

void vmuShutdown() {
	sem_signal(quit_sem);
	thd_wait(thd_hnd);
	sem_destroy(quit_sem);
}

