/*
   Feet of Fury

   menu_extras/slotsMenu.h

   Copyright (C)2003 Cryptic Allusion, LLC

   See the file LICENSE for more info on usage.

   $Id: slotsMenu.h,v 1.2 2003/05/03 19:29:44 bard Exp $
*/

#ifndef __SLOTS_MENU_H
#define __SLOTS_MENU_H

#include "widget.h"
#include "extrasMenu.h"

class TextDisplay;
class Slot;

class SlotsMenu : public ExtrasMenu {
public:
	SlotsMenu(MenuExtras * parent, ExtrasMenu * back);
	virtual ~SlotsMenu();

	// Overrides
	virtual void inputEvent(const GenericMenu::Event & evt);
	virtual void gainFocus();

	void stopped();

private:
	// Update the various text buffers for the cursor pos
	void	updateBuffers();

	RefPtr<Texture>		m_txrSlots;

	RefPtr<Label>		m_title;

	RefPtr<Label>		m_creditsLbl;
	RefPtr<Label>		m_credits;
	RefPtr<Label>		m_winLbl;
	RefPtr<Label>		m_win;
	RefPtr<TextDisplay>	m_td;
	RefPtr<Slot>		m_slot;

	RefPtr<Sound>		m_sfxFail, m_sfxSucceed;

	char			m_creditsBuf[64];
	char			m_winBuf[64];
	bool			m_dirty;

	ExtrasMenu		* m_back;
};

#endif	// __SLOTS_MENU_H

